// flirc - a smallweigth FLTK irc client
// Copyright (C) 2001 Georg Lukas <georg@boerde.de>
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// $Id: setup_win.cxx,v 1.1.1.1 2001/02/18 15:42:57 ge0rg Exp $

#include "globals.h"
#include "irc.h"
#include "mystr.h"

Fl_Window *setup_win;
Fl_Input *setup_server, *setup_nick, *setup_nick2, *setup_user, *setup_name;


/********** Setup stuff **********/
void setup_cancel_cb(Fl_Widget *w, void *data) {
	setup_win->hide();
}
void setup_save_cb(Fl_Widget *w, void *data) {
	fl_alert("Not yet implemented!");
}
void setup_load_cb(Fl_Widget *w, void *data) {
	fl_alert("Not yet implemented!");
}
void setup_ok_cb(Fl_Widget *w, void *data) {
	//strncpy(irc_server, setup_server->value(), 32);
	if (!irc_setnick(setup_nick->value())) {
		irc_nick = strnew(setup_nick->value());
	}
	irc_user = strnew(setup_user->value());
	irc_name = strnew(setup_name->value());
	setup_win->hide();
}
void setup_connect_cb(Fl_Widget *w, void *data) {
	setup_ok_cb(w, data);
	irc_disc("Changing servers");
	irc_server(setup_server->value());
}

Fl_Button *setup_create_button(int x, int y, char *label, Fl_Callback *cb) {
	Fl_Button *b;
	b = new Fl_Button(x, y, 48, 18, label);
	b->labelfont(MENU_FONT);
	b->labelsize(MENU_FONTSIZE);
	b->callback(cb);
	return b;
}

Fl_Input *setup_create_input(int y, char *label) {
	Fl_Input *i;
	i = new Fl_Input(56, y, 100, 16, label);
	i->textfont(MENU_FONT);
	i->textsize(MENU_FONTSIZE);
	i->labelfont(MENU_FONT);
	i->labelsize(MENU_FONTSIZE);
	return i;
}

void setup_create_win() {
	Fl_Button *bn;
	// Setup window construction
	setup_win = new Fl_Window(160,154, TITLE " Configuration");
	setup_win->set_modal();

	setup_server = setup_create_input(4, "Server: ");
	setup_nick = setup_create_input(24, "Nickname: ");
	//setup_nick2 = setup_create_input(44, "Alt. Nick: ");
	setup_user = setup_create_input(64, "User: ");
	setup_name = setup_create_input(84, "Realname: ");

	setup_create_button(4, 110, "&Ok", setup_ok_cb);
	setup_create_button(56, 110, "&Save", setup_save_cb);
	setup_create_button(108, 110, "Cancel", setup_cancel_cb);

	bn = setup_create_button(4, 132, "&Connect", setup_connect_cb);
	setup_create_button(56, 132, "&Load", setup_load_cb);
	setup_create_button(108, 132, "&Quit", (Fl_Callback*)flirc_quit);

	setup_win->end();
}

void setup_run_win() {
	//setup_server->value(irc_server);
	setup_nick->value(irc_nick);
	setup_user->value(irc_user);
	setup_name->value(irc_name);
	setup_win->show();
}

